<?php  
$config = parseLaomaoFile('.laomao');  
$telegramBotToken = $config['TELEGRAM_BOT_TOKEN'] ?? '';  
$telegramBotApiUrl = "https://api.telegram.org/bot$telegramBotToken";  
$shellScammerApiUrl = $config['SHELL_SCAMMER_API_URL'] ?? '';  
$shellScammerToken = $config['SHELL_SCAMMER_TOKEN'] ?? '';  
$advertisementText = file_get_contents('top.txt');  
$advertisementText = implode("\n", array_map('trim', explode("\n", $advertisementText))) . "\n\n";
$managedUsers = file('manage.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);  

array_walk($managedUsers, function (&$value) {  
    $value = trim($value);  
    if (strpos($value, '@') === 0) {  
        $value = substr($value, 1);  
    }  
}); 

function parseLaomaoFile(string $filePath): array {  
    $config = [];  
    if (file_exists($filePath)) {  
        $lines = file($filePath, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);  
        foreach ($lines as $line) {  
            if (strpos($line, '=') !== false) {  
                list($key, $value) = explode('=', $line, 2);  
                $config[trim($key)] = trim($value);  
            }  
        }  
    }  
    return $config;  
}


function handleTelegramUpdate(array $update): void {  
    global $telegramBotApiUrl, $shellScammerApiUrl, $shellScammerToken, $advertisementText;  
    $message = $update['message'] ?? null;  
    if (!$message) {  
        return;  
    }
    $chat = $message['chat'];  
    $chatId = $chat['id'];  
    $text = trim($message['text']);  
    $isGroup = isset($chat['type']) && in_array($chat['type'], ['group', 'supergroup']);  
    $validCommands = ['user', 'address', 'report'];  
    $command = null;  
    $argument = null;  
    if (strpos($text, '/') === 0) {  
        [$command, $argument] = explode(' ', substr($text, 1), 2) + [1 => null];  
        $command = trim($command);  
        $argument = trim($argument);  
        if ($argument && strpos($argument, '@') === 0) {  
            $argument = substr($argument, 1);  
        }  
        if (!in_array($command, $validCommands)) {  
            if (!$isGroup) {  
                sendMessage($chatId, "🈚 该命令: {$command}");  
            }  
            return;  
        }  
    } else {  
        if (!$isGroup) {  
            sendMessage($chatId, "🈚 无效的指令格式");  
        }  
        return;  
    }  
        if (in_array($command, ['user', 'address']) && !$argument) {  
        sendMessage($chatId, "⛔ 参数不能为空");  
        return;  
    }
    if (in_array($argument, $GLOBALS['managedUsers'])) {  
        sendMessage($chatId, "🚫 禁止对管理员进行操作");  
        return;  
    }
    $replyText = $isGroup ? '' : $advertisementText;
    switch ($command) {  
        case 'user':  
            $replyText .= queryScammer($shellScammerApiUrl, 'query_user', $argument, $chatId);  
            break;  
        case 'address':  
            $replyText .= queryScammer($shellScammerApiUrl, 'query_address', $argument, $chatId);  
            break;  
        case 'report':  
            $commandArguments = array_filter(explode('-', $argument), 'trim');  
            if (count($commandArguments) < 5) {  
                sendMessage($chatId, "✅ 示范: /report 飞机号-骗子昵称-骗子USDT地址-被骗描述-被骗金额(不可为0)");  
                return;  
            }  
            $reportData = [  
                'username' => $commandArguments[0],  
                'aircraft_name' => $commandArguments[1],  
                'receipt_address' => $commandArguments[2],  
                'description' => $commandArguments[3],  
                'deceived_amount' => $commandArguments[4],  
            ];  
            $replyText .= reportFraudster($shellScammerApiUrl, $reportData, $chatId);  
            break;  
    }  
    sendMessage($chatId, $replyText);  
}

function queryScammer(string $apiUrl, string $type, ?string $value, int $chatId): string {    
    global $shellScammerToken;    
    if (!in_array($type, ['query_user', 'query_address']) || $value === null) {    
        return "😑 无效的查询类型或值\n";    
    }  
    $data = [    
        'token' => $shellScammerToken,    
         $type => $value,  
    ];  
    $response = sendCurlRequest($apiUrl, json_encode($data));      
    $result = json_decode($response, true);  
    if (empty($result)) {      
        return "😑 未找到\n";      
    }  
    if (isset($result['status']) && $result['status'] === 'error') {      
        return "😑 查询出错\n";      
    }
    return buildUserInfoString($result);    
}
function buildUserInfoString(array $result): string {  
    $userInfo = "查询结果：\n";  
    foreach ($result as $item) {  
        $userInfo .= "编号: " . ($item['id'] ?? '未知') . "\n";  
        $userInfo .= "飞机号: " . ($item['username'] ?? '未知') . "\n";  
        $userInfo .= "骗子名称: " . ($item['aircraft_name'] ?? '未知') . "\n";  
        $userInfo .= "骗子地址: " . ($item['receipt_address'] ?? '未知') . "\n";  
        $userInfo .= "被骗经过: " . ($item['description'] ?? '无描述') . "\n"; 
        $userInfo .= "被骗U子: " . ($item['deceived_amount'] ?? '未知数量') . "\n";  
        $userInfo .= "────────⚠️该用户有行骗记录，谨慎交易⚠️────────\n";  
    }  
      
    return $userInfo;  
}


function sendCurlRequest(string $url, string $postData): string {  
    $ch = curl_init($url);  
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);  
    curl_setopt($ch, CURLOPT_POST, true);  
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);  
    $response = curl_exec($ch);  
    curl_close($ch);  
    return $response;  
}  
function reportFraudster(string $apiUrl, array $reportData, int $chatId): string {  
    global $shellScammerToken;  
    $data = [  
        'token' => $shellScammerToken,  
        'report' => $reportData,  
    ];
    $response = sendCurlRequest($apiUrl, json_encode($data));  
    $result = json_decode($response, true);  
  
if (isset($result['status']) && $result['status'] === 'success') {   
    return "🟢 提交成功\n";    
} else {    
    return "🔴 重复提交\n";    
    }
}  

function sendMessage(int $chatId, string $text): void {  
    global $telegramBotApiUrl;  
    $data = [  
        'chat_id' => $chatId,  
        'text' => $text,  
    ];  
  
    sendCurlRequest($telegramBotApiUrl . '/sendMessage', json_encode($data));  
}
if ($_SERVER['REQUEST_METHOD'] === 'POST') {  
    $content = file_get_contents('php://input');  
    $update = json_decode($content, true);  
    if ($update) {  
        handleTelegramUpdate($update);  
    }  
}